import javax.microedition.lcdui.*; //User Interface Package
import javax.microedition.midlet.*; // Interfacce ei il ciclo di vita della MIDlet
import javax.microedition.io.*; 
import java.io.*;
import javax.bluetooth.*;
import java.util.Vector; //per i Vector


//INIZIO PROGRAMMA
public class BTSPPclient extends MIDlet implements CommandListener, DiscoveryListener {
	public Display display;
  	public Form form_inizio;
  	public Form form_about;
  	public Form form_send;
 	public Command cmExit;
 	public Command cmSearch;
 	public Command cmSend;
 	public Command cmBack;
 	public Command cmBackSearch;
 	public Command cmAbout;
	public List BTDlist;
	public TextField message = new TextField("", "DeSantiX.iT", 160, TextField.ANY);
 	//BT
 	public LocalDevice device;
	public DiscoveryAgent agent;
	public String MAC_DEV;

	public void destroyApp(boolean unconditional) { }
  	public void pauseApp() { }

	public void startApp() {
	    display = Display.getDisplay(this);	
	    //CREA I COMANDI    
	    cmExit = new Command("Exit", Command.EXIT, 1); 
	    cmSearch = new Command ("Cerca", Command.SCREEN, 2 );
	    cmSend = new Command ("Invia", Command.SCREEN, 2 );
	    cmBack = new Command("Back", Command.BACK, 2);
	    cmBackSearch = new Command ("Back", Command.SCREEN, 2 );
	    cmAbout = new Command ("About", Command.SCREEN, 3 );
	   
	    
	    form_inizio = new Form("BTSPPclient");  //INTESTAZIONE DEL FORM
	    form_about = new Form("BTSPPclient");
	    form_send = new Form("BTSPPclient");
	    
	    //Inserisce i comandi nel form_inizio
	    form_inizio.addCommand(cmExit); 
	    form_inizio.addCommand(cmSearch);
	    form_inizio.addCommand(cmAbout);
	    form_send.addCommand(cmExit); 
	    form_send.addCommand(cmSend);
	    //form_send.addCommand(cmSearch);
	    form_send.addCommand(cmBackSearch);
	    form_send.append("Invio della stringa\n" );
	    form_send.append(message);
	    
	    form_about.addCommand(cmExit); 
	    form_about.addCommand(cmBack);
	    form_about.append("BTSPPclient V.1.0\n\nDev by DeSantiX.iT\nwww.desantix.it\ndesantis@desantix.it");
	    
	    form_send.setCommandListener(this);
	    form_about.setCommandListener(this);	    
	    form_inizio.setCommandListener(this);
	   		 	    
	    
	    display.setCurrent(form_inizio); //Setta il Form di partenza
	
	    //BT
	    try {
	    	device = LocalDevice.getLocalDevice(); // obtain reference to singleton
     	 	String address = device.getBluetoothAddress();
         	form_inizio.append("Il mio MAC BT: " + address + "\n");
         	form_inizio.append("Il mio NOME: " + device.getFriendlyName() + "\n");
         	device.setDiscoverable(DiscoveryAgent.GIAC); // set Discover mode to GIAC
	    } catch (BluetoothStateException e){
          	show_alert ("Errore BT\n" + e.getMessage(), 1, -2, form_inizio);
     	    } 	    
     	    form_inizio.append("seleziona \"Cerca\" per avviare la ricerca dei dispositivi Bluetooth\n");
     	}
	
	//METODO: 2 parametri il primo rappresenta il tasto premuto il secondo rappresenta il contenitore 
	public void commandAction(Command command, Displayable displayable){	
	  if (command == cmExit){  //PRESSIONE TASTO EXIT
	  	device=null;
	  	agent=null;
	  	destroyApp(false);
	  	notifyDestroyed();
	  //PRESSIONE TASTO CERCA
	  } else if(command == cmSearch) {
	    //>6
	    if (form_inizio.size()> 3)
	    	form_inizio.delete(form_inizio.size()-1);	
	    form_inizio.append("Ricerca in corso....\n");
	    BTDlist = null;
	    BTDlist = new List( "DEVICE TROVATI:", List.IMPLICIT ); //Crea una lista
	    BTDlist.setCommandListener(this);
	    //Avvio la ricerca di dispositivi BT
	    try {
	    	agent = device.getDiscoveryAgent(); // obtain reference to singleton
	    	agent.startInquiry( DiscoveryAgent.GIAC, this );   	
	    } catch (BluetoothStateException e){
          	show_alert ("Errore BT\n" + e.getMessage(), 1, -2, form_inizio);
     	    }	
     	  //SELEZIONATA VOCE NELLA LIST
	  } else if (command == List.SELECT_COMMAND){ 
	  	int selectedIndex = BTDlist.getSelectedIndex();
		MAC_DEV = (BTDlist.getString(selectedIndex));
		if (form_send.size() > 2)
	  		form_send.delete(form_send.size()-1); //Rimuove  l'ultimo elemento dall'form inizio
	  	form_send.append("\nal device con MAC:\n" + MAC_DEV);
	  	display.setCurrent(form_send);
	  //PRESSIONE TASTO INVIO 		
	  }  else if(command == cmSend) {
	  	//Invia la stringa al Device BT
	  	String connString = "btspp://" + MAC_DEV + ":1;master=false;encrypt=false;authenticate=false";
          	if (connString != null){
               		try{
                    		StreamConnection conn = (StreamConnection)
                    		Connector.open(connString); 
                    		
                    		OutputStream out = conn.openOutputStream();
                    		String buff_message = message.getString();
                    		out.write(buff_message.getBytes());
                    		out.close();
                    		conn.close();
                    		show_alert ("Invio riuscito", 0, 3000, form_send);                   
               		} catch (IOException e){
               			//ALERT
                    		show_alert ("Invio al device BT fallito", 1, -2, form_send);
               		}
      		} else {
      			//ALERT
               		show_alert ("Impossibile trovare il device BT", 1, -2, form_send);  
          	}
          //PRESSIONE TASTO BACK
	  }  else if(command == cmBack) {
	  	display.setCurrent(form_inizio); 
	  //PRESSIONE ABOUT	
	  }  else if(command == cmAbout) {
	  	display.setCurrent(form_about);
	  //PRESSIONE TASTO BACK NEL FORM SEACH 
	  }  else if(command == cmBackSearch) {
	  	form_inizio.delete(form_inizio.size()-1);
	  	display.setCurrent(form_inizio); //Mostra la lista
	  }	
	} 
	//metodo chiamato appena viene trovato un dispositivo BT
	public void deviceDiscovered(RemoteDevice remoteDevice, DeviceClass deviceClass){
	     //aggiunge il MAC del Device BT trovato nella List solo se questo  un PC
	     if ((deviceClass.getMajorDeviceClass() == 0x100) || (deviceClass.getMajorDeviceClass() == 0x1F00)) {
	     	BTDlist.append(remoteDevice.getBluetoothAddress(), null);	
	     }
	} 
	//metodo chiamato appena viene terminata la ricerca!
	public void inquiryCompleted(int discoveryType)  {
		if (BTDlist.size() > 0) { 
			display.setCurrent(BTDlist); //Mostra la lista
		} else {
			show_alert ("Nessun device BT trovato!", 2, 3000,  form_inizio);
		}
		
    	}
	public void serviceSearchCompleted(int transId, int responseCode) { }
    	public void servicesDiscovered(int transId, ServiceRecord[] serviceRecords) { }
    	
    	//Visualizza i messaggi d'errore 
    	public void show_alert (String Message, int Type, int TimeOut, Form Form){
    		String title;
    		AlertType alertType;
    		switch (Type)  {
    			default:
    			case 0:	//CONFERMA
    				title = "Conferma";
    				alertType = AlertType.CONFIRMATION;
    			break;
    			case 1: //ERRORE
    				title = "Attenzione";
    				alertType = AlertType.ERROR;
    			break; 
    			case 2:	//INFO
    				title = "Info";
    				alertType = AlertType.INFO;
    			break;		
    		}
    		Alert alert = new Alert(title, Message, null, alertType);	
            	alert.setTimeout(TimeOut);
            	display.setCurrent(alert, Form);    	
    	}
    	
}